package de.unirostock.Singleton.example.gui;

import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.border.LineBorder;

import de.unirostock.Singleton.example.ShipMarket;


public class ShipMarketPanel extends javax.swing.JPanel {
	
	private JLabel lNumShips;

	private boolean init	= false;
	
	public ShipMarketPanel() {
		super();
		initGUI();
	}
	
	public void paint( Graphics g ){
		if( !init ) return;
		lNumShips.setText( ""+ShipMarket.getInstance().getNumShipsToSell());
		super.paint( g );
	}
	
	private void initGUI() {
		try {
			GridBagLayout thisLayout = new GridBagLayout();
			this.setLayout(thisLayout);
			this.setBackground(new java.awt.Color(250,248,238));
			this.setBorder(new LineBorder(new java.awt.Color(0,0,0), 1, true));
			{
				JLabel lHeadline = new JLabel();
				this.add(lHeadline, new GridBagConstraints(
					0,
					0,
					2,
					1,
					0.0,
					0.0,
					GridBagConstraints.CENTER,
					GridBagConstraints.NONE,
					new Insets(5, 0, 0, 0),
					0,
					0));
				lHeadline.setText("Schiffsmarkt");
				lHeadline.setFont(new java.awt.Font("Arial",1,16));
			}
			{
				JLabel lImage = new JLabel();
				this.add(lImage, new GridBagConstraints(
					0,
					1,
					2,
					1,
					0.0,
					0.0,
					GridBagConstraints.CENTER,
					GridBagConstraints.NONE,
					new Insets(10, 5, 10, 5),
					0,
					0));
				lImage.setIcon(new ImageIcon(getClass().getClassLoader()
					.getResource("images/ShipMarket.gif")));
			}
			{
				JLabel lText = new JLabel();
				this.add(lText, new GridBagConstraints(
					0,
					3,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.CENTER,
					GridBagConstraints.NONE,
					new Insets(0, 6, 20, 0),
					0,
					0));
				lText.setText("Anzahl Schiffe:");
				lText.setFont(new java.awt.Font("Arial",0,12));
			}
			{
				lNumShips = new JLabel();
				this.add(lNumShips, new GridBagConstraints(
					1,
					3,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.LINE_END,
					GridBagConstraints.NONE,
					new Insets(0, 0, 20, 6),
					0,
					0));
				lNumShips.setText("0");
				lNumShips.setFont(new java.awt.Font("Arial",0,12));
			}
			init = true;
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
