/**
 * Created on 24.03.2005
 *
 * @author Jens Guenther
 */
package de.unirostock.Singleton.example;

public class Shipowner
{
	private int itsNumOwnedShips;
	private ShipMarket	shipMarket;
	
	public Shipowner( int numOwnedShips ){
		if( numOwnedShips < 0 )	itsNumOwnedShips = 0;
		else					itsNumOwnedShips = numOwnedShips;
		shipMarket	= ShipMarket.getInstance();
	}
	
	public void sellShipOnMarket() {
		if( itsNumOwnedShips > 0 ){
			shipMarket.buyShip();
			itsNumOwnedShips--;
		}
	}

	public void buyShipOnMarket() {
		if( shipMarket.sellShip() ){
			itsNumOwnedShips++;
		}
	}

	public int getNumOwnedShips() {
		return itsNumOwnedShips;
	}

	public int getNumShipsOnMarket() {
		return shipMarket.getNumShipsToSell();
	}

}
