package de.unirostock.Singleton.example.gui;

import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.WindowConstants;
import javax.swing.border.LineBorder;

import de.unirostock.Singleton.example.Shipowner;

public class ShipOwnerPanelLeft extends javax.swing.JPanel
implements ActionListener
{
	
	private Shipowner	itsShipOwner;
	
	private static final String BT_SELL	= "SELL";
	private static final String BT_BUY	= "BUY";
	
	private JLabel lNumShipsOwned;
	private JLabel lNumShipsMarket;

	private boolean init	= false;
	
	public ShipOwnerPanelLeft( Shipowner owner ) {
		itsShipOwner = owner;
		initGUI();
	}
	
	public void actionPerformed( ActionEvent e ){
		if( e.getActionCommand().equals( BT_SELL )){
			itsShipOwner.sellShipOnMarket();
		}
		if( e.getActionCommand().equals( BT_BUY )){
			itsShipOwner.buyShipOnMarket();
		}
		getParent().repaint();
	}
	
	public void paint( Graphics g ){
		if( !init ) return;
		lNumShipsOwned.setText( ""+itsShipOwner.getNumOwnedShips());
		lNumShipsMarket.setText( ""+itsShipOwner.getNumShipsOnMarket());
		super.paint( g );
	}
	
	private void initGUI() {
		try {
			GridBagLayout thisLayout = new GridBagLayout();
			this.setLayout(thisLayout);
			this.setBackground(new java.awt.Color(250,248,238));
			this.setBorder(new LineBorder(new java.awt.Color(0,0,0), 1, true));
			{
				JLabel lHeadline = new JLabel();
				this.add(lHeadline, new GridBagConstraints(
					0,
					0,
					3,
					1,
					0.0,
					0.0,
					GridBagConstraints.CENTER,
					GridBagConstraints.NONE,
					new Insets(5, 0, 0, 0),
					0,
					0));
				lHeadline.setText("Reederei Markusson");
				lHeadline.setFont(new java.awt.Font("Arial",1,16));
			}
			{
				JLabel lImage = new JLabel();
				this.add(lImage, new GridBagConstraints(
					0,
					1,
					2,
					2,
					0.0,
					0.0,
					GridBagConstraints.CENTER,
					GridBagConstraints.NONE,
					new Insets(10, 5, 10, 0),
					0,
					0));
				lImage.setIcon(new ImageIcon(getClass().getClassLoader()
					.getResource("images/ShipOwner.gif")));
			}
			{
				JLabel lTextShipsOwned = new JLabel();
				this.add(lTextShipsOwned, new GridBagConstraints(
					0,
					3,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.LINE_START,
					GridBagConstraints.NONE,
					new Insets(0, 6, 0, 0),
					0,
					0));
				lTextShipsOwned.setText("Anzahl Schiffe:");
				lTextShipsOwned.setFont(new java.awt.Font("Arial",0,12));
			}
			{
				lNumShipsOwned = new JLabel();
				this.add(lNumShipsOwned, new GridBagConstraints(
					1,
					3,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.LINE_END,
					GridBagConstraints.NONE,
					new Insets(0, 0, 0, 6),
					0,
					0));
				lNumShipsOwned.setText( ""+itsShipOwner.getNumOwnedShips());
				lNumShipsOwned.setFont(new java.awt.Font("Arial",0,12));
			}
			{
				JLabel lTextShipsMarket = new JLabel();
				this.add(lTextShipsMarket, new GridBagConstraints(
					0,
					4,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.CENTER,
					GridBagConstraints.NONE,
					new Insets(0, 6, 5, 0),
					0,
					0));
				lTextShipsMarket.setText("Schiffe erwerbbar:");
				lTextShipsMarket.setFont(new java.awt.Font("Arial",0,12));
			}
			{
				lNumShipsMarket = new JLabel();
				this.add(lNumShipsMarket, new GridBagConstraints(
					1,
					4,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.LINE_END,
					GridBagConstraints.NONE,
					new Insets(0, 0, 5, 6),
					0,
					0));
				lNumShipsMarket.setText( ""+itsShipOwner.getNumShipsOnMarket());
				lNumShipsMarket.setFont(new java.awt.Font("Arial",0,12));
			}
			{
				JButton btSell = new JButton( "Schiff verkaufen >>" );
				this.add(btSell, new GridBagConstraints(
					2,
					1,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.SOUTH,
					GridBagConstraints.NONE,
					new Insets(12, 5, 0, 5),
					0,
					0));
				btSell.setActionCommand( BT_SELL );
				btSell.addActionListener( this );
				btSell.setFont(new java.awt.Font("Arial",0,12));
			}
			{
				JButton btBuy = new JButton( "<< Schiff kaufen" );
				this.add(btBuy, new GridBagConstraints(
					2,
					2,
					1,
					1,
					0.0,
					0.0,
					GridBagConstraints.NORTH,
					GridBagConstraints.HORIZONTAL,
					new Insets(5, 5, 0, 5),
					0,
					0));
				btBuy.setActionCommand( BT_BUY );
				btBuy.addActionListener( this );
				btBuy.setFont(new java.awt.Font("Arial",0,12));
			}
			init = true;
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * For testing purpose only.
	 */
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.getContentPane().add(new ShipOwnerPanelLeft( new Shipowner(10)));
		frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		frame.pack();
		frame.setVisible( true );
	}
}
